概:近一个月leetcode出了一个月的并查集每日一题,有人惊呼:“这个月不学会并查集谁也别想走”,于是在通过找一些资料学习,并锤炼一些每日一题后,我有了自己的感悟,决定记下来。本篇主要讲述并查集抽象思维和案例(LeetCode_778_水位上升的泳池中游泳)的做法。
来源:力扣(LeetCode)
链接:LeetCode_778_水位上升的泳池中游泳
在一个 N x N 的坐标方格 grid 中,每一个方格的值 grid[i][j] 表示在位置 (i,j) 的平台高度。
现在开始下雨了。当时间为 t 时,此时雨水导致水池中任意位置的水位为 t 。你可以从一个平台游向四周相邻的任意一个平台,但是前提是此时水位必须同时淹没这两个平台。假定你可以瞬间移动无限距离,也就是默认在方格内部游动是不耗时的。当然,在你游泳的时候你必须待在坐标方格里面。
你从坐标方格的左上平台 (0,0) 出发。最少耗时多久你才能到达坐标方格的右下平台 (N-1, N-1)?
示例 1:
输入: [[0,2],[1,3]]
输出: 3
解释:
时间为0时,你位于坐标方格的位置为 (0, 0)。
此时你不能游向任意方向,因为四个相邻方向平台的高度都大于当前时间为 0 时的水位。
等时间到达 3 时,你才可以游向平台 (1, 1). 因为此时的水位是 3,坐标方格中的平台没有比水位 3 更高的,所以你可以游向坐标方格中的任意位置
示例2:
输入: [[0,1,2,3,4],[24,23,22,21,5],[12,13,14,15,16],[11,17,18,19,20],[10,9,8,7,6]]
输出: 16
解释:
0 1 2 3 4
24 23 22 21 5
12 13 14 15 16
11 17 18 19 20
10 9 8 7 6
最终的路线用加粗进行了标记。
我们必须等到时间为 16,此时才能保证平台 (0, 0) 和 (4, 4) 是连通的
1)2 <= N <= 50.
2)grid[i][j] 是 [0, …, N*N - 1] 的排列。
class Unionfind
{
public:
vector<int> parents;
Unionfind(int n)
{
for (int i = 0; i < n; i++)
{
parents.push_back(i);
}
}
int Find(int x)
{
if (parents[x] == x) return x;
else return Find(parents[x]);
}
void marge(int x,int y)
{
if (Find(x) != Find(y))
{
parents[Find(x)] = Find(y);
}
}
bool rt()
{
if (Find(0) == Find(parents.size() - 1)) return true;
else return false;
}
};
class Solution {
public:
map<int, vector<int>> ma;
int swimInWater(vector<vector<int>>& heights) {
for (int i = 0; i < heights.size(); i++)
for (int j = 0; j < heights[0].size(); j++)
{
insert(i* heights[0].size() + j, heights[i][j]);
}
Unionfind uf(heights.size() * heights[0].size());
map<int, vector<int>>::iterator it = ma.begin();
for (int i = 0; i < ma.size(); i++)
{
vector<int>& ve = it->second;
for (int j = 0; j < ve.size(); j ++)
{
int x = ve[j]/heights[0].size();
int y = ve[j]%heights[0].size();
if(x-1>=0&&heights[x-1][y]<=heights[x][y])
uf.marge(ve[j],ve[j]-heights[0].size());
if(x+1<heights.size()&&heights[x+1][y]<=heights[x][y])
uf.marge(ve[j],ve[j]+heights[0].size());
if(y-1>=0&&heights[x][y-1]<=heights[x][y])
uf.marge(ve[j],ve[j]-1);
if(y+1<heights[0].size()&&heights[x][y+1]<=heights[x][y])
uf.marge(ve[j],ve[j]+1);
}
if (uf.rt()) return it->first;
it++;
}
return 0;
}
void insert(int x, int h)
{
if (ma.count(h) == 0) ma.insert(pair<int, vector<int>>(h, vector<int>()));
ma.find(h)->second.push_back(x);
}
};